' FastMode sample
' Copyright (c) 2005 Hai Li, Zeal SoftStudio.
' E-Mail:support@zealsoft.com
' http://www.zealsoft.com (English)
' http://zealsoft.nease.net/ (Chinese)
' This sample illustrates how to use the fast mode of
' NTPort Library to increase performance.

#INCLUDE ONCE "win/kernel32.bi" 
#INCLUDE ONCE "win/user32.bi" 
#INCLUDE ONCE "win/mmsystem.bi" 
#include once "NTPort.bi"
'$inclib: "ntport"

#define TRUE 1
#define FALSE 0

Declare Sub fbOut(Byval nPort As Integer, Byval value As Integer)
Declare Function fbInp(Byval nPort As Integer) As Integer
Declare Function GetHiResTime() As Double
Declare Sub FastModeTest(Byval nPort As Long, Byval nTimes As Long)
Declare Sub NormalModeTest(Byval nPort As Long, Byval nTimes As Long)

Dim sValue As String
Dim As Long nPort, nTimes

Print "FastMode Sample"
Print "Copyright (c) 2005 Zeal SoftStudio."
Print 

Line Input "I/O Address[200]: "; sValue
If sValue = "" Then sValue = "200"
' Get the address of the port
nPort = Val(sValue)
Line Input "Times[1000]: "; sValue
If sValue = "" Then sValue = "1000"
' Get the address of the port
nTimes = Val(sValue)
NormalModeTest(nPort, nTimes)
FastModeTest(nPort, nTimes)
Sleep

' If you want to call this subroutine under Windows NT/200/XP/Server 2003,
' you must call EnablePort first.
Sub fbOut(Byval nPort As Integer, Byval value As Integer)
    Asm
        mov AX, [value]
        mov DX, [nPort]
        out DX, AL
    End Asm
End Sub

' If you want to call this functon under Windows NT/200/XP/Server 2003,
' you must call EnablePort first.
Function fbInp(Byval nPort As Integer) As Integer
    Asm
        mov DX, [nPort]
        in  AL, DX
        mov [Function], AL
    End Asm
End Function

' Get high resolution time
Function GetHiResTime() As Double
    Dim Cnt As INT64, Freq As INT64
    If QueryPerformanceFrequency(Freq) Then
        QueryPerformanceCounter Cnt
        GetHiResTime = Cnt / Freq * 1000.0
    Else
        GetHiResTime = timeGetTime()
    End If
End Function

Sub FastModeTest(Byval nPort As Long, Byval nTimes As Long)
    Dim tTime As Double
    Dim nData As Long
    Dim i As Integer

    ' Check the OS
    If IsWinNT() = 0 Then
        Print "Fast mode is designed for Windows NT/2000/XP users, not Windows 95/98/ME user!"
        Exit Sub
    End If

    ' Using fast mode
    SetFastMode TRUE

    ' To use the fast mode, you must call EnablePorts
    ' before you call the Inport, Outport, and other
    ' functions.
    EnablePorts nPort, nPort

    ' Test the result of EnablePorts
    Dim s As String
    s = SPACE$(200)
    If GetLastState(s) <> ERROR_NONE Then
        Print "Error:" + s
        Exit Sub
    End If

    ' If you are using Evaluation version, this
    ' statement will show the registration reminder
    ' dialog. If you are using the registered version,
    ' please call LicesnseInfo instead.
    nData = Inpb(nPort)

    ' Start the time count
    tTime = GetHiResTime

    ' Read the port in a loop
    For i = 1 To nTimes
        nData = fbInp(nPort)
    Next

    ' Stop the time count
    tTime = GetHiResTime() - tTime

    ' Free the resource
    DisablePorts nPort, nPort

    ' Show the result
    Print Using "Fast mode time cost: ####.####ms"; tTime
End Sub

Sub NormalModeTest(Byval nPort As Long, Byval nTimes As Long)
    Dim tTime As Double
    Dim nData As Long
    Dim i As Integer

    ' Using normal mode
    SetFastMode FALSE

    ' If you are using Evalualtion version, this
    ' statement will show the registration reminder
    ' dialog. If you are using the registered version,
    ' please call LicesnseInfo instead.
    nData = Inpb(nPort)

    ' Test the result of Inp
    Dim s As String
    s = SPACE$(200)
    If GetLastState(s) <> ERROR_NONE Then
        Print "Error:" + s
        Exit Sub
    End If

    ' Start the time count
    tTime = GetHiResTime

    ' Read the port in a loop
    For i = 1 To nTimes
        nData = Inpb(nPort)
    Next

    ' Stop the time count
    tTime = GetHiResTime() - tTime

    ' Show the result
    Print Using "Normal mode time cost: ####.####ms"; tTime
End Sub
