#ifndef NTPORT_BI
#define NTPORT_BI
'============================================================================'
'NTPort Library for using FreeBasic compiler '
' Copyright (c) 1997-2005 Hai Li, Zeal SoftStudio.
' E-Mail: support@zealsoft.com
' Web: http://www.zealsoft.com
'============================================================================'

' Constants used for GetLastState function
#define ERROR_NONE 0
#define ERROR_DRIVER 2
#define ERROR_SCM_CANT_CONNECT 9998

' EnablePorts procedure will enable your application to read or write specific ports
Declare Sub EnablePorts Lib "ntport" Alias "EnablePorts" (Byval portStart As Short, Byval portEnd As Short)

' DisablePorts procedure will disable your application to read or write specific ports.
Declare Sub DisablePorts Lib "ntport" Alias "DisablePorts" (Byval portStart As Short, Byval portEnd As Short)

' Returns the setting of fast mode.
Declare Function GetFastMode Lib "ntport" Alias "GetFastMode"() As Integer

' Returns a value indicating the last operation is successful or not.
Declare Function GetLastState Lib "ntport" Alias "GetLastState" (Byval sStatus As String) As Integer

' Returns a value indicating the base address of LPT ports.
Declare Function GetLPTPortAddress Lib "ntport" Alias "GetLPTPortAddress" (Byval portID As Short) As Short

' Returns the version of NTPort Library.
Declare Function GetNTPortVersion Lib "ntport" Alias "GetNTPortVersion" () As Short

' Returns a value indicates whether the application is running under Windows NT/2000/XP/Server 2003 system.
Declare Function IsWinNT Lib "ntport" Alias "IsWinNT" () As Integer

' Returns a value indicates whether the application is running under 64-bit Windows system.
Declare Function IsWin64 Lib "ntport" Alias "IsWin64" () As Integer

' Set the setting of fast mode.
Declare Sub SetFastMode Lib "ntport" Alias "SetFastMode" (Byval bOption As Integer)


' Set the registration information.
Declare Sub LicenseInfo Lib "ntport" Alias "LicenseInfo" (Byval sUser As String, Byval lKey As Integer)

' Inp and Inport will return a byte from a specific port.
Declare Function Inpb Lib "ntport" Alias "Inp" (Byval portID As Short) As Short
Declare Function Inport Lib "ntport" Alias "Inport" (Byval portID As Short) As Short

' Inpw and InportW will return a word from specific ports.
Declare Function Inpw Lib "ntport" Alias "Inpw" (Byval portID As Short) As Short
Declare Function InportW Lib "ntport" Alias "InportW" (Byval portID As Short) As Short

' Inpd and InportD will return a double word from specific ports.
Declare Function Inpd Lib "ntport" Alias "Inpd" (Byval portID As Short) As Integer
Declare Function InportD Lib "ntport" Alias "InportD" (Byval portID As Short) As Integer

' Outp and Outport will write a byte from a specific port.
Declare Sub Outp Lib "ntport" Alias "Outp" (Byval portID As Short, Byval nByte As Short)
Declare Sub Outport Lib "ntport" Alias "Outport" (Byval portID As Short, Byval nByte As Short)

' Outpw and OutportW will write a word to specific ports
Declare Sub Outpw Lib "ntport" Alias "Outpw" (Byval portID As Short, Byval nWord As Short)
Declare Sub OutportW Lib "ntport" Alias "OutportW" (Byval portID As Short, Byval nWord As Short)

' Outpd and OutportD will write a double word to specific ports.
Declare Sub Outpd Lib "ntport" Alias "Outpd" (Byval portID As Short, Byval nWord As Integer)
Declare Sub OutportD Lib "ntport" Alias "OutportD" (Byval portID As Short, Byval nWord As Integer)

#endif ' NTPORT_BI