' PortTest sample
' Copyright (c) 2005 Hai Li, Zeal SoftStudio.
' E-Mail:support@zealsoft.com
' http://www.zealsoft.com (English)
' http://zealsoft.nease.net/ (Chinese)
' This sample illustrates how to use NTPort
' Library to read or write PC I/O ports.

'' compile with:  fbc -s gui PortTest.rc PortTest.bas 

#INCLUDE ONCE "win/kernel32.bi" 
#INCLUDE ONCE "win/user32.bi" 
#include once "NTPort.bi"
'$inclib: "ntport"

#define TRUE 1
#define FALSE 0

#include "PortTest.bi"

Declare Function DlgProc ( Byval hWnd As Long, Byval uMsg As Long, Byval wParam As Long, Byval lParam As Long ) As Integer 
                                

''' 
''' Program start 
'''      
   ' After register NTPort Library,
   ' place your registration information here.
   LicenseInfo "Your Name", 0
    '' 
    '' Create the Dialog 
    '' 
    DialogBoxParam(GetModuleHandle (NULL), Byval IDD_PORTTEST_DIALOG, NULL, @DlgProc, NULL) 
    
    
    '' 
    '' Program has ended 
    '' 
    ExitProcess (0) 
    End 

''' 
''' Program end 
'''      

Function btnRead_Click(portID As Integer, nSize As Integer) As Integer
    Dim inNum As Integer 
    Dim s As String, sText As String

    Select Case nSize
    Case 1
        ' Byte
        inNum = Inport(portID)
    Case 2
        inNum = InportW(portID)
    Case 4
        inNum = InportD(portID)
    End Select

    btnRead_Click = inNum
End Function

Sub btnWrite_Click(portID AS INTEGER, nSize As Integer, outNum As Integer)
    Select Case nSize
    Case 1
        ' Byte
        Outport portID, outNum
    Case 2
        ' Word
        OutportW portID, outNum
    Case 4
        ' DWord
        OutportD portID, outNum
    End Select
End Sub

Function DlgProc ( Byval hDlg As Long, Byval uMsg As Long, Byval wParam As Long, Byval lParam As Long ) As Integer 
    Dim As Long id, event
    Dim s As String
    Dim portID As Integer, nData As Integer, nSize As Integer
   
    '' 
    '' Process message 
    '' 
    Select Case uMsg
    Case WM_INITDIALOG
        SetDlgItemText(hDlg, IDC_EDIT1, "61")
        SendDlgItemMessage(hDlg, IDC_RADIO1, BM_SETCHECK, BST_CHECKED, 0)

    '' 
    '' Window was closed 
    '' 
    Case WM_CLOSE
        EndDialog( hDlg, 0 ) 

    Case WM_COMMAND
		id    = Loword( wParam )
		event = Hiword( wParam )

        If IsDlgButtonChecked(hDlg, IDC_RADIO1) Then
            ' Byte
            nSize = 1
        Elseif IsDlgButtonChecked(hDlg, IDC_RADIO2) Then
            ' Word
            nSize = 2
        Elseif IsDlgButtonChecked(hDlg, IDC_RADIO3) Then
            ' DWord
            nSize = 4
        End If

        s = SPACE$(30)
        GetDlgItemText(hDlg, IDC_EDIT1, s, 30)
        portID = Val("&H" + Trim(s))

        Select Case id
        Case IDC_READ
            nData = btnRead_Click(portID, nSize)
            s = "In " + HEX$(portID) + "H, " + HEX$(nData) + "H"
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, 0, StrPtr(s))
            ' Get Error Information
            s = SPACE$(30)
            GetLastState s
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETCURSEL, _
                SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, 0, StrPtr(s)), 0)     

        Case IDC_WRITE
            s = SPACE$(30)
            GetDlgItemText(hDlg, IDC_EDIT2, s, 30)
            nData = Val("&H" + Trim(s))
            btnWrite_Click(portID, nSize, nData)
            s = "Out " + HEX$(portID) + "H, " + HEX$(nData) + "H"
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, 0, StrPtr(s))
            ' Get Error Information
            s = SPACE$(30)
            GetLastState s
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETCURSEL, _
                SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, 0, StrPtr(s)), 0)     

        Case IDCANCEL
            EndDialog( hDlg, 0)
    	End Select
        
    Case Else
    	Return 0 
    
    End Select
    
   Return 1 
End Function 
